"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SeedRelation = void 0;
const seeder_factory_1 = require("../seeder/seeder.factory");
const relationships_1 = require("../relationships");
const pick_1 = require("../relationships/pick");
function SeedRelation(classRef, pick, options = {}) {
    return (target, propertyKey) => {
        let pickFn = async (_faker, context) => {
            const relatedClass = classRef();
            if (context.savedEntities.has(relatedClass)) {
                const idColumns = context.dataSource
                    .getMetadata(relatedClass)
                    .primaryColumns.map((c) => c.propertyName);
                return (0, pick_1.pickRelated)(context, idColumns, context.savedEntities.get(relatedClass), pick, options.many);
            }
            else {
                return new relationships_1.ForwardRef(propertyKey, context, relatedClass, pick, options);
            }
        };
        Reflect.defineMetadata(Symbol("Seeder relation factory"), new seeder_factory_1.SeederFactory(propertyKey, pickFn), target.constructor);
    };
}
exports.SeedRelation = SeedRelation;
