"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Seed = void 0;
const seeder_factory_1 = require("../seeder/seeder.factory");
function Seed(arg) {
    return (target, propertyKey) => {
        var _a;
        const existingSymbols = Reflect.getMetadataKeys(target.constructor);
        // Check if somewhere in the prototype chain, or on ourselves, we already have a
        // factory for the same `propertyKey` ...
        const symbol = (_a = existingSymbols.find((symbol) => {
            var _a;
            return ((_a = Reflect.getMetadata(symbol, target.constructor)) === null || _a === void 0 ? void 0 : _a.propertyKey) ===
                propertyKey;
        }
        // ... if so, use it. If not, create a new one.
        )) !== null && _a !== void 0 ? _a : Symbol("Seeder factory metadata");
        Reflect.defineMetadata(
        // (over)write new/existing metadata symbol for the propertyKey.
        symbol, new seeder_factory_1.SeederFactory(propertyKey, arg), target.constructor);
    };
}
exports.Seed = Seed;
