import { Type } from "@nestjs/common";
import { SeederContext, SeedRelationPicker } from "../interfaces";
export declare type ClassRef<T> = () => new () => T;
export declare abstract class Ref<T> {
    propertyKey: string | symbol;
    readonly context: SeederContext;
    readonly refClass: Type<T>;
    readonly pick: SeedRelationPicker<T>;
    readonly options: any;
    selfClass: Type;
    selfId: number;
    constructor(propertyKey: string | symbol, context: SeederContext, refClass: Type<T>, pick: SeedRelationPicker<T>, options?: any);
    abstract resolve(entities: any[]): Promise<any>;
}
export declare class ForwardRef<T> extends Ref<T> {
    resolve(entities: T[]): Promise<any>;
}
