"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ForwardRef = exports.Ref = void 0;
const pick_1 = require("./pick");
class Ref {
    constructor(propertyKey, context, refClass, pick, options = {}) {
        this.propertyKey = propertyKey;
        this.context = context;
        this.refClass = refClass;
        this.pick = pick;
        this.options = options;
        this.selfClass = context.currentClass;
        this.selfId = context.currentIndex;
        this.context = Object.assign({}, context);
    }
}
exports.Ref = Ref;
class ForwardRef extends Ref {
    async resolve(entities) {
        const self = this.context.savedEntities.get(this.selfClass)[this.selfId];
        const idColumns = this.context.dataSource
            .getMetadata(this.refClass)
            .primaryColumns.map((col) => col.propertyName);
        self[this.propertyKey] = await (0, pick_1.pickRelated)(this.context, idColumns, entities, this.pick);
        return this.context.dataSource.getRepository(this.selfClass).save(self);
    }
}
exports.ForwardRef = ForwardRef;
