"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SeederService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("typeorm");
let SeederService = class SeederService {
    constructor(dataSource, seeders, refresh = false, repeats = 1) {
        this.dataSource = dataSource;
        this.seeders = seeders;
        this.refresh = refresh;
        this.repeats = repeats;
        this.logger = new common_1.Logger("Seeder");
    }
    async run() {
        if (this.refresh) {
            await this.drop();
        }
        return await this.seed();
    }
    async createContext() {
        return {
            dataSource: this.dataSource,
            currentRecords: new Map(),
            savedEntities: new Map(),
            unresolvedReferences: [],
        };
    }
    async seed() {
        for (let i = 0; i < this.repeats; i++) {
            if (this.repeats > 1) {
                this.logger.log(`Repeating seeders ${i} out of ${this.repeats} times.`);
            }
            const context = await this.createContext();
            // Seed seeders in forward order
            for (const seeder of this.seeders) {
                await seeder.seed(context);
                this.logger.log(`${seeder.getName()} completed.`);
            }
        }
    }
    async drop() {
        // Drop seeders in reverse order
        for (const seeder of this.seeders.slice().reverse()) {
            await seeder.drop({ dataSource: this.dataSource });
            this.logger.log(`${seeder.getName()} dropped.`);
        }
    }
};
SeederService = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [typeorm_1.DataSource, Array, Boolean, Number])
], SeederService);
exports.SeederService = SeederService;
