import { Logger, Provider, Type } from "@nestjs/common";
import { DropContext, SeederContext } from "../interfaces/context.interface";
import { SeederFactory } from "../seeder/seeder.factory";
import { Seeder } from "../seeder/seeder.interface";
export interface ClassSeederOptions<T> {
    readonly count?: number;
    readonly seeder?: new () => ClassSeeder<T>;
}
export declare class ClassSeeder<T, RecordOfT extends Record<keyof T, any> = Record<keyof T, any>> implements Seeder {
    protected readonly seedClass: Type<T>;
    protected readonly options: ClassSeederOptions<T>;
    protected factories: {
        [K in keyof T]?: SeederFactory;
    };
    protected logger: Logger;
    constructor(seedClass: Type<T>, options: ClassSeederOptions<T>);
    getName(): string;
    seed(context: SeederContext): Promise<(RecordOfT & T)[]>;
    drop(ctx: DropContext): Promise<void>;
    getBatchSize(): Promise<number>;
    createRecords(n: number, context: SeederContext): Promise<RecordOfT[]>;
    createRecord(context: SeederContext): Promise<RecordOfT>;
}
export declare function createClassSeeder<T>(seedClass: Type<T>, options?: ClassSeederOptions<T>): Provider<ClassSeeder<T>>;
export declare function createClassSeeders(seedClasses: Type[], options?: ClassSeederOptions<any> | ClassSeederOptions<any>[]): Provider<ClassSeeder<any>>[];
export declare function getSeedFactories<T extends Type>(seedClass: T): {
    [K in keyof T]?: SeederFactory;
};
